//
// Created by robtor on 05.01.23.
//

#ifndef FLOATPUMP_CONFIG_STORE_H
#define FLOATPUMP_CONFIG_STORE_H

#include <chrono>

namespace floatpump {

    class Config_Store {
    public:
        Config_Store();

        void saveToFlash();

        void resetDefaults();

        void loadFromFlash();

        template<class T>
        class Config_Object {
        public:
            Config_Object(T initialValue) : m_data(initialValue) {};

            T getValue() {
                return m_data;
            }

            void setValue(T newValue) {
                m_data = newValue;
            }

            T *getLink() {
                return &m_data;
            }

        private:
            T m_data;
        };


        Config_Object<bool> testbool = Config_Object<bool>(false);
    };

} // floatpump

#endif //FLOATPUMP_CONFIG_STORE_H
